import React, { useEffect, useState, useContext } from "react";
import Grid from "./components/Grid";
import Select from "./components/Select";
import ImagesContext from "./store/images-context";
import { ToastContainer, toast } from 'react-toastify';
import 'react-toastify/dist/ReactToastify.min.css'

const initialLayout = {
  cols: [
    {
      id: 1,
      image: "",
      width: 100,
      height: 100,
    },
  ],
};

function App() {
  const [layout, setLayout] = useState(initialLayout);
  const [layoutFormat, setLayoutFormat] = useState({
    name: "16:9",
    class: "sixteen-by-nine",
    height: 562,
    width: 1000
  });

  const imageCTX = useContext(ImagesContext);

  useEffect(() => {
    imageCTX.images.forEach(image => {
      layout.cols = layout.cols.map(item => {
        if (image.id === item.id) {
          item.image = image.image;
        }

        if (Array.isArray(item.height)) {
          item.height.map(subItem => {
            if (image.id === subItem.id) {
              subItem.image = image.image;
            }
            return subItem;
          })
        }

        return item;
      })
      setLayout(layout);
    });

  }, [imageCTX.images, layout]);

  return <div className="App">
    <ToastContainer position={toast.POSITION.BOTTOM_LEFT} />
    <Select setLayout={setLayout} setLayoutFormat={setLayoutFormat} />
    <Grid classes={layoutFormat.class} layout={layout} layoutFormat={layoutFormat} />
  </div>;
}

export default App;
